using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;



namespace WINDF7CSharp
{
    public partial class FContrdes : Form
    {
        public const int maxrtc = 10;         // definiert in UnitController
        public const int maxn=20;             //{ max degree of HF(z)  }

        public const int max2n=40,            //{ a,b of HF(z) }
                         maxnp2=13;           //maxn+2;

        char       algorithm;           //i:ideal, r: real   definiert in UnitController

        double phireg,tab,kr,wd,krp,wdp,krn,wdn,tn,tnn,
            tv,tvd,st,sd,krd,wdd,t0,
            kp,ti,td,kri,wdi,si,tni,tvi,krb,krb1,phir;
        double kpt1cd,tpt1cd,k2pt1cd,t12pt1cd,t22pt1cd,kit1cd,tit1cd,tzafcd;
        public int _mgradcd;
        int processmodel,cdct;
        public double [] tetacd = new double[max2n];
        double[] KT = new double[maxnp2];



        String wdnotfound,nmbrsdntfit,nmbrsfit,ptype;
        //string processname="From Controller Design";
        public string b0notpossible;

        public double      q0p,q0n,q1n,q0d,q1d,q0i,
                    q1i,q2i; //{PID-params in UnitController,}

        public double[] pv = new double[maxnp2 + 1];    // DB (v) Standard
        public double[] qv = new double[maxnp2 + 1];  
        public double[] p1v = new double[maxnp2 + 1];   // DB(v+1)
        public double[] q1v = new double[maxnp2 + 1];
        public double[] p2v = new double[maxnp2 + 1];   // Orienteering controller
        public double[] q2v = new double[maxnp2 + 1];
        public double f3or;  // Orientering Contr



//---------------------------------------------------------------------------

        FormMain meinMain;
        public FContrdes(FormMain m)
        {
            InitializeComponent();
            meinMain = m;
            //coeffCD = "Coeff";
            nmbrsdntfit = "Numbers don't fit";
            //firstdefdigfilt = "First define a digital filter in the main menu";
            nmbrsfit = "Controllers are designed";
            wdnotfound = "Crossover frequency not found";
            b0notpossible = " b0 is herenot possible";
            k2pt1cd = 2.0; t12pt1cd = 0.05; t22pt1cd = 0.03;
            kit1cd = 3.0; tit1cd = 0.03; kpt1cd = 2; tpt1cd = 0.1; phir = 60.0;
            t0 = 0.01;
            //dataGridView1.Visible = false;
            //if (digfilavailableCD) Btofz.Enabled = true;
            processmodel = 1;
            _mgradcd = 2;
            edk.Text = (kit1cd).ToString("G10");
            Edt1.Text = (tit1cd).ToString("G10");
            Edt2.Visible = false;
            edtt.Text = (tzafcd).ToString("G10");
            edto.Text = (t0 * 1e3).ToString("G10");
            edphir.Text = (phir).ToString("G10");
            rbit1_Click(null, null);                 // Click on IT1
            radioButton6_CheckedChanged(null, null);  /// Click on real Algorithm
            ptype = "IT1";
        }

        //---------------------------------------------------------------------------
      
 


void displaypq(double[] p, double[] q, int m)
{
    int i;
    dataGridView2.RowCount = 0;
    dataGridView2.Rows.Add(q[0].ToString("G8"), "xxx"); /*q0   1*/
    dataGridView2.Rows[0].HeaderCell.Value = "0";
    for (i = 1; i <= m; i++)
    {
        dataGridView2.Rows.Add(q[i].ToString("G8"), p[i].ToString("G8")); /*qi   pi*/
        dataGridView2.Rows[i ].HeaderCell.Value = (i).ToString();
    } /*for (*/


}

//---------------------------------------------------------------------------

void tetatocell()
{
    int i;
    dataGridView1.RowCount = 0;
    for (i = 1; i <= _mgradcd; i++)
    {
        dataGridView1.Rows.Add(tetacd[i].ToString("G10"), tetacd[_mgradcd + 1 + i].ToString("G10")); /*bi*/
        dataGridView1.Rows[i - 1].HeaderCell.Value = i.ToString();
    } /*for (*/


}


//---------------------------------------------------------------------------


 void suche_wd(double T1,double T2,double T3,double Tt,double phi, ref double w)

         /* T1,T2 timeconstants ) 2 PT1, phi process phase(wd), w :wd
           T3 PD-t.c. */
         /* normally 2PT1 with delay + PD-Block
                  if ( T2=0, ) Pt1 with delay + PD
                  if ( T2=1e10, ) IT1 with delay + PD  */
         /* Nested interval method for ( searching wd
           solving ) equation
           phisuch=f=arcMath.Tan(w * T1) + arcMath.Tan(w * T2) - arcMath.Tan(w * T3) + w * Tt
           phisuch is angle in rad, phi ist Winkel in Grad */

    {
      int i;
      double anf,ende,wmaxTt,phisuch,f;
      phisuch=Math.PI/180.0*(-phi); /*pos. process phase in rad*/
      wmaxTt=phisuch/Tt; /* delay phase for ( starting */
      ende=wmaxTt;
      anf=0;i=0;
      do {
        w=anf+(ende-anf)/2.0; /*w lays in the interval anf-ende */
          f=Math.Atan(w*T1)+Math.Atan(w*T2)-Math.Atan(w*T3)+w*Tt;
        if ( f>phisuch ) ende=w ;else anf=w;
        i++;
        }
      while ((Math.Abs(f-phisuch)>1e-4) && (i<30));
      if ( i>30 ) MessageBox.Show(wdnotfound);
    }  /* void suche_wd */

//---------------------------------------------------------------------------

void numbersfit()
{
    lfit.Text = nmbrsfit;
    lfit.ForeColor = Color.Black;
}

//---------------------------------------------------------------------------


void numbersdntfit()
{
    lfit.Text =nmbrsdntfit;
    lfit.ForeColor=Color.Red;

}
//---------------------------------------------------------------------------


void string2off()
{
    //dataGridView2.Visible=false;

}


//---------------------------------------------------------------------------


void string1on()
{
        //this.dataGridView1.Visible=true;
        this.Ldegree.Visible=true;
        this.degreen.Visible=true;
        this.edphir.Visible=false;
        this.edk.Visible=false;
        this.edtt.Visible=false;
        this.Edt1.Visible=false;
        this.label1.Visible=false;
        this.label2.Visible=false;
        this.label4.Visible=false;
        this.Label7.Visible=false;

        this.lwd.Visible=false;
        this.lkr.Visible=false;
        this.ltn.Visible=false;
        this.ltv.Visible=false;
        this.lst.Visible=false;
        this.Label5.Visible=false;       /*T0=...ms not useful with F(z)*/
        this.Label19.Visible=false;
        this.edto.Visible=false;
        //this.Btofz.Visible=true;

}

//---------------------------------------------------------------------------


void string2on()
{
        //this.dataGridView2.Visible=true;
        this.lwd.Visible=false;
        this.lkr.Visible=false;
        this.ltn.Visible=false;
        this.ltv.Visible=false;
        this.lst.Visible=false;

}


//---------------------------------------------------------------------------


void display()
{

    if (rbp.Checked)/*P*/
    {//string2off();
        this.lwd.Visible = true;
        this.lkr.Visible = true;
        this.ltn.Visible = false;
        this.ltv.Visible = false;
        this.lst.Visible = false;
        this.lq0.Visible = true;
        this.lq1.Visible = false;
        this.lq2.Visible = false;
        this.lp1.Visible = true;
        this.lp3.Visible = false;
        this.lp2.Visible = false;
        this.edwd.Visible = true;
        this.edkr.Visible = true;
        this.edtn.Visible = false;
        this.edtv.Visible = false;
        this.edst.Visible = false;
        this.edq0.Visible = true;
        this.edq1.Visible = false;
        this.edq2.Visible = false;
        this.edp1.Visible = true;
        this.edp2.Visible = false;
        this.edp3.Visible = false;
        this.edwd.Text = (wdp).ToString("G10");
        this.edkr.Text = (krp).ToString("G10");
        this.edq0.Text = (q0p).ToString("G10");
        this.edp1.Text = (0).ToString("G10");
        if ( krp!=0 ) this.endgain.Text=(1.0/krp).ToString("G10");

    }
    if (rbpdt1.Checked)
    {  /*PD*/
        string2off();
        this.lwd.Visible = true;
        this.lkr.Visible = true;
        this.ltn.Visible = false;
        this.ltv.Visible = true;
        this.lst.Visible = true;
        this.lq0.Visible = true;
        this.lq1.Visible = true;
        this.lq2.Visible = false;
        this.lp1.Visible = true;
        this.lp3.Visible = false;
        this.lp2.Visible = false;
        this.edwd.Visible = true;
        this.edkr.Visible = true;
        this.edtn.Visible = false;
        this.edtv.Visible = true;
        this.edst.Visible = true;
        this.edq0.Visible = true;
        this.edq1.Visible = true;
        this.edq2.Visible = false;
        this.edp1.Visible = true;
        this.edp2.Visible = false;
        this.edp3.Visible = false;
        this.edwd.Text = (wdd).ToString("G10");
        this.edkr.Text = (krd).ToString("G10");
        this.edq0.Text = (q0d).ToString("G10");
        this.edp1.Text = (0).ToString("G10");
        this.edq1.Text = (q1d).ToString("G10");
        this.edtv.Text = (tvd).ToString("G10");
        this.edst.Text = (sd).ToString("G10");
        if ( krd!=0 ) this.endgain.Text=(1.0/krd).ToString("G10");

    }
    if (rbpi.Checked)
    {  /*PI*/
        string2off();
        this.lwd.Visible = true;
        this.lkr.Visible = true;
        this.ltn.Visible = true;
        this.ltv.Visible = false;
        this.lst.Visible = false;
        this.lq0.Visible = true;
        this.lq1.Visible = true;
        this.lq2.Visible = false;
        this.lp1.Visible = true;
        this.lp3.Visible = false;
        this.lp2.Visible = false;
        this.edwd.Visible = true;
        this.edkr.Visible = true;
        this.edtn.Visible = true;
        this.edtv.Visible = false;
        this.edst.Visible = false;
        this.edq0.Visible = true;
        this.edq1.Visible = true;
        this.edq2.Visible = false;
        this.edp1.Visible = true;
        this.edp2.Visible = false;
        this.edp3.Visible = false;
        this.edwd.Text = (wdn).ToString("G10");
        this.edkr.Text = (krn).ToString("G10");
        this.edq0.Text = (q0n).ToString("G10");
        this.edq1.Text = (q1n).ToString("G10");
        this.edp1.Text = (1).ToString("G10");
        this.edtn.Text = (tnn).ToString("G10");
        this.endgain.Text="0";

    }
    if (rbpidt1.Checked)
    {  /*PID*/
        string2off();
        this.lwd.Visible = true;
        this.lkr.Visible = true;
        this.ltn.Visible = true;
        this.ltv.Visible = true;
        this.lst.Visible = true;
        this.lq0.Visible = true;
        this.lq1.Visible = true;
        this.lq2.Visible = true;
        this.lp3.Visible = false;
        this.lp1.Visible = true;
        this.lp2.Visible = false;
        this.edwd.Visible = true;
        this.edkr.Visible = true;
        this.edtn.Visible = true;
        this.edtv.Visible = true;
        this.edst.Visible = true;
        this.edq0.Visible = true;
        this.edq1.Visible = true;
        this.edq2.Visible = true;
        this.edp1.Visible = true;
        this.edp2.Visible = false;
        this.edp3.Visible = false;
        this.edwd.Text = (wdi).ToString("G10");
        this.edkr.Text = (kri).ToString("G10");
        this.edq0.Text = (q0i).ToString("G10");
        this.edp1.Text = (1).ToString("G10");
        this.edq1.Text = (q1i).ToString("G10");
        this.edq2.Text = (q2i).ToString("G10");
        this.edtv.Text = (tvi).ToString("G10");
        this.edtn.Text = (tni).ToString("G10");
        this.edst.Text = (si).ToString("G10");
        this.endgain.Text="0";


    }
    if (rbdbv.Checked)
    {  /*DB*/
        string2on();
        displaypq(pv,qv,_mgradcd);
        double krb = meinMain.datatools.disturbanceGain(pv, qv, _mgradcd,algorithm);
        this.endgain.Text=(krb).ToString("G10");

    }
    if (rbdbv1.Checked)
    {  /*DB(v+1)*/
        string2on();
        displaypq(p1v,q1v,_mgradcd+1);
        double krb = meinMain.datatools.disturbanceGain(p1v, q1v, _mgradcd+1, algorithm);
        this.endgain.Text=(krb).ToString("G10");

    }
    if (rbor.Checked)
    {  /*OR*/
        string2on();
        displaypq(p2v,q2v,_mgradcd);
        this.endgain.Text="n.def.";

    }


} /*display*/

//---------------------------------------------------------------------------

void string1off()
{
        //this.dataGridView1.Visible=false;
        this.Ldegree.Visible=false;
        this.degreen.Visible=false;
        this.edphir.Visible=true;
        this.edk.Visible=true;
        this.edtt.Visible=true;
        this.Edt1.Visible=true;
        this.label1.Visible=true;
        this.label2.Visible=true;
        this.label4.Visible=true;
        this.Label6.Visible=true;
        this.Label7.Visible=true;
        this.Label5.Visible=true;       /*T0=...ms*/
        this.Label19.Visible=true;
        this.edto.Visible=true;
        //this.Btofz.Visible=false;

    display();
}

//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
void designDBOR()
{
    meinMain.datatools.DB_aus_teta(tetacd, ref pv, ref qv, _mgradcd);
    krb = meinMain.datatools.disturbanceGain(pv, qv, _mgradcd,algorithm);
    meinMain.datatools.DB1_aus_teta(tetacd, ref p1v, ref q1v, _mgradcd, 1);
    krb1 = meinMain.datatools.disturbanceGain(p1v, q1v, _mgradcd + 1,algorithm);
    meinMain.datatools.OR_aus_teta(tetacd, ref p2v, ref q2v, _mgradcd, ref f3or);
}


public void deutsch()
{
    //coeffCD = "Koeff";
    //firstdefdigfilt="Definiere zuerst ein digitales Filter im Hauptmen";

    design.Text = "Entwurf d. Reg.";
    rgpt.Text = "Strecke";
    RGir.Text = "Algorithmus";
    rgct.Text = "Regler";
    dgain.Text = "Strverstrkung";
    this.Text = "Automatischer Reglerentwurf";
    nmbrsfit = "Regler sind ausgelegt";
    nmbrsdntfit = "Zahlen passen nicht !!";

    //Btofz.toolTip1="Speichere F(z) mit Filter Daten ";
    //Bfztodf.ToolTip="Lade F(z) von *.fz- Datei";
    
    wdnotfound = "Durchtrittsfrequenz nicht gefunden";
    Ldegree.Text = "Grad von F(z)";
    printbtn.Text = "-> Report";
    numbersfit();
    rbreal.Text = "real";
    //processname = "Strecke aus Reglerauslegung";
    b0notpossible = "b0 ist nicht mglich in diesem Fenster";
    toolTip1.SetToolTip(Btofz, "Speichere Strecke als *.fz- Datei");
    toolTip1.SetToolTip(Bfztodf, "Lade Strecke als *.fz- Datei und konvertiere ggf in PT- Werte");
}

//---------------------------------------------------------------------------


double phirg(double phir) /* table page 26 */
{
  if ( phir>=55 ) return(-15);
    else if ( phir>=45 ) return(-20);
       else if ( phir>=35 ) return(-24);
          else return(-30)  ;
}
//---------------------------------------------------------------------------

double sqr(double x)
{return(x*x);
}

//---------------------------------------------------------------------------

double tangr(double a)  /* a in degree*/

{
  double arad=a/180.0*Math.PI;
  return(Math.Tan(arad));
} /*tan*/

//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
       
        private void CancelBtn_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void printbtn_Click(object sender, EventArgs e)
        {
            int i;
            String bl="              ",h="",bl2="  ";
            String a = "      ", CR = "\r\n"; ;
            meinMain.tBMainReport.AppendText(a + "_____________________________________________________" + CR);
            meinMain.tBMainReport.AppendText(a + CR);
            meinMain.tBMainReport.AppendText(a + this.Text + CR);
            meinMain.tBMainReport.AppendText(a + CR);

            //RichTextBox1.AppendText(bl+Caption);  //nur auf Drucker
            
            meinMain.tBMainReport.AppendText(bl+rgpt.Text+" : "+ptype+CR);/*process*/
            if ((processmodel>=0)&&(processmodel<3))
            {
                h = (bl + label1.Text + " = " + edk.Text );
                h = h + (bl2 + label2.Text + " = " + Edt1.Text + " s" );
                if (processmodel==0)//2PT1
                    h=h+(bl2+label3.Text+" = "+Edt2.Text+" s");
                meinMain.tBMainReport.AppendText(h+CR);
                meinMain.tBMainReport.AppendText(bl + label4.Text + " = " + edtt.Text + " s" + CR);
                h=(bl+Label5.Text+" = "+edto.Text+" ms");
                meinMain.tBMainReport.AppendText(h + bl2 + Label6.Text + " = " + edphir.Text + CR);
                meinMain.tBMainReport.AppendText(bl + CR);
                h=(bl2+RGir.Text+" : ");
                if (algorithm == 'i') h = h + "ideal"; else h = h + rbreal.Text;
                meinMain.tBMainReport.AppendText(bl+rgct.Text+h+ CR); /* controller */
                meinMain.tBMainReport.AppendText(bl + CR);
                meinMain.tBMainReport.AppendText(bl + "P" + CR);
                meinMain.tBMainReport.AppendText(bl+"wd= "+(wdp).ToString("G10")+
                   "   Kr= " + (krp).ToString("G10") + CR);
                meinMain.tBMainReport.AppendText(bl + lq0.Text + "= " + (q0p).ToString("G10") + CR);
                if ( krp!=0 )
                    meinMain.tBMainReport.AppendText(bl + dgain.Text + "= " + (1 / krp).ToString("G10") + CR);
                meinMain.tBMainReport.AppendText(bl + CR);
                meinMain.tBMainReport.AppendText(bl + "PI" + CR);
                meinMain.tBMainReport.AppendText(bl+"wd= "+(wdn).ToString("G10")+
                               "   Kr= "+(krn).ToString("G10")+
                               "   Tn= " + (tnn).ToString("G10") + CR);
                meinMain.tBMainReport.AppendText(bl+lq0.Text+"= "+(q0n).ToString("G10")+"  "+
                   lq1.Text + "= " + (q1n).ToString("G10") + "  p1=1" + CR);
                meinMain.tBMainReport.AppendText(bl + CR);
                meinMain.tBMainReport.AppendText(bl + "PD(T1)" + CR);
                meinMain.tBMainReport.AppendText(bl+"wd= "+(wdd).ToString("G10")+
                   "   Kr= "+(krd).ToString("G10")+
                   "   Tv= "+(tvd).ToString("G10")+
                   "   st= " + (sd).ToString("G10") + CR);
                meinMain.tBMainReport.AppendText(bl+lq0.Text+"= "+(q0d).ToString("G10")+"  "+
                   lq1.Text + "= " + (q1d).ToString("G10") + "  p1=0" + CR);
                if ( krd!=0 )
                    meinMain.tBMainReport.AppendText(bl + dgain.Text + "= " + (1 / krd).ToString("G10") + CR);
                meinMain.tBMainReport.AppendText(bl + CR);
                meinMain.tBMainReport.AppendText(bl + "PID(T1)" + CR);
                meinMain.tBMainReport.AppendText(bl+"wd= "+(wdi).ToString("G10")+
                   "   Kr= "+(kri).ToString("G10")+
                   "   Tn= " + (tni).ToString("G10") + CR);
                meinMain.tBMainReport.AppendText(bl+"Tv= "+(tvi).ToString("G10")+
                   "   st= " + (si).ToString("G10") + CR);
                meinMain.tBMainReport.AppendText(bl+lq0.Text+"= "+(q0i).ToString("G10")+"  "+
                   lq1.Text+"= "+(q1i).ToString("G10")+"  "+
                   lq2.Text + "= " + (q2i).ToString("G10") + "  p1=1" + CR);
                meinMain.tBMainReport.AppendText(bl + CR);
            }  /*pid controller*/

            meinMain.tBMainReport.AppendText(bl + "F(z)" + CR);
            for ( i=1;i<=_mgradcd;i++ )
                meinMain.tBMainReport.AppendText(bl+"a("+(i).ToString()+")= "+(tetacd[i]).ToString("G10")+"  "+
                   "b(" + (i).ToString() + ")= " + (tetacd[_mgradcd + i + 1]).ToString("G10") + "  " + CR);
            meinMain.tBMainReport.AppendText(bl + "Dead-Beat(v)" + CR);
            meinMain.tBMainReport.AppendText(bl+"q(0)= "+(qv[0]).ToString("G10")+"  "+
                   "p(0)= XXX" + CR);
            for ( i=1;i<=_mgradcd;i++ )
                meinMain.tBMainReport.AppendText(bl+"q("+(i).ToString()+")= "+(qv[i]).ToString("G10")+"  "+
                   "p(" + (i).ToString() + ")= " + (pv[i]).ToString("G10") + "  " + CR);
            meinMain.tBMainReport.AppendText(bl + dgain.Text + "= " + (krb).ToString("G10") + CR);
            meinMain.tBMainReport.AppendText(a + "_____________________________________________________" + CR);
        }

//-------------------------------------------------------------------------------------------------------------------

        private void design_Click(object sender, EventArgs e)
        {
            double weg;
            meinMain.ConvertToDouble(edtt.Text, ref tzafcd);
            meinMain.ConvertToDouble(edto.Text, ref t0);/* times in sec */
            t0 = t0 / 1000.0;
            meinMain.ConvertToDouble(edphir.Text, ref phir);

            if (algorithm == 'i') tab = 0.5 * t0; else tab = 1.5 * t0;
            if (rbit1.Checked)///*it1*/ )
            {
                meinMain.ConvertToDouble(edk.Text, ref kit1cd);
                meinMain.ConvertToDouble(Edt1.Text, ref tit1cd);
                /* P-controller for ( it1 */
                suche_wd(tit1cd, 1e10, 0, tab + tzafcd, -180 + phir, ref wd);
                kr = wd * Math.Sqrt(1 + sqr(wd * tit1cd)) / kit1cd;
                q0p = kr; krp = kr; wdp = wd;


                /* PI-controller for ( it1 */
                phireg = phirg(phir);  /*calc the phase ) PI- contr. at wd for ( symm opt*/
                suche_wd(tit1cd, 1e10, 0, tab + tzafcd, -180 + phir - phireg, ref wd);
                tn = tangr(90 + phireg) / wd;
                kr = wd * Math.Sqrt(1 + sqr(wd * tit1cd)) / kit1cd * wd * tn / (Math.Sqrt(1 + sqr(wd * tn))); /* */
                q0n = kr * (1 + t0 / tn); q1n = -kr; krn = kr; wdn = wd; tnn = tn;

                /* PDT1-controller for ( it1 */
                tv = tit1cd;       /* polecompensation */
                st = 1 + tv / t0;
                suche_wd(tit1cd / st, 1e10, 0, tab + tzafcd, -180 + phir, ref wd);
                kr = wd * Math.Sqrt(1 + sqr(wd * tit1cd / st)) / kit1cd;
                q0d = kr * (1 + tv / t0); q1d = -kr * (tv / t0);
                krd = kr; wdd = wd; sd = st; tvd = tv;

                /* PIDT1 controller for ( it1 */
                phireg = phirg(phir);  /*calc the phase ) PI- contr. at wd for ( symm opt*/
                tv = tit1cd;       /* polecompensation*/
                st = 1 + tv / t0;
                suche_wd(tit1cd / st, 1e10, 0, tab + tzafcd, -180 + phir - phireg, ref wd);
                tn = tangr(90 + phireg) / wd;
                kr = wd * Math.Sqrt(1 + sqr(wd * tit1cd / st)) / kit1cd * wd * tn / (Math.Sqrt(1 + sqr(wd * tn)));
                kp = kr * (tv + tn) / tn; ti = tv + tn; td = tv * tn / ti;
                q0i = kp * (1 + td / t0 + t0 / ti);
                q1i = -kp * (1 + 2.0 * td / t0); q2i = kp * td / t0;
                kri = kr; wdi = wd; si = st; tni = tn; tvi = tv;
                //kttotetacd();
                //this.degreen.Value = _mgradcd;
                //tetatocell();
                KT[0] = kit1cd; KT[1] = tit1cd; KT[2] = 0; KT[3] = t0;
                meinMain.datatools.kttoteta(processmodel, KT, ref tetacd);
                this.degreen.Value = _mgradcd;
                tetatocell();
            } /*it1*/
            if (rb2pt1.Checked)///*2Pt1*/ )
            {
                meinMain.ConvertToDouble(edk.Text, ref k2pt1cd);
                meinMain.ConvertToDouble(Edt1.Text, ref t12pt1cd);
                meinMain.ConvertToDouble(Edt2.Text, ref t22pt1cd);
                if (t12pt1cd < t22pt1cd)
                { weg = t22pt1cd; t22pt1cd = t12pt1cd; t12pt1cd = weg; } /*swap*/
                /* first P-controller  */
                suche_wd(t12pt1cd, t22pt1cd, 0, tab + tzafcd, -180 + phir, ref wd);  /*  */
                kr = Math.Sqrt(1 + sqr(wd * t12pt1cd)) * Math.Sqrt(1 + sqr(wd * t22pt1cd)) / k2pt1cd;
                q0p = kr; krp = kr; wdp = wd;

                /*  PI-controller  */
                suche_wd(1e10, t22pt1cd, 0, tab + tzafcd, -180 + phir, ref wd);  /*  */
                kr = wd * t12pt1cd * Math.Sqrt(1 + sqr(wd * t22pt1cd)) / k2pt1cd; tnn = t12pt1cd;
                q0n = kr * (1 + t0 / t12pt1cd); q1n = -kr; krn = kr; wdn = wd;

                /*  PDT1-controller */
                tv = t22pt1cd;       /* polecompensation */
                st = 1 + tv / t0;
                suche_wd(t12pt1cd, tv / st, 0, tab + tzafcd, -180 + phir, ref wd);  /*  */
                kr = Math.Sqrt(1 + sqr(wd * tv / st)) * Math.Sqrt(1 + sqr(wd * t12pt1cd)) / k2pt1cd;
                q0d = kr * (1 + tv / t0); q1d = -kr * (tv / t0);
                krd = kr; wdd = wd; sd = st; tvd = tv;

                /*  PIDt1cd-controller */
                tv = t22pt1cd; tn = t12pt1cd;       /* polecompensation */
                st = 1 + tv / t0;
                suche_wd(1e10, tv / st, 0, tab + tzafcd, -180 + phir, ref wd);  /*  */
                kr = wd * tn * Math.Sqrt(1 + sqr(wd * tv / st)) / k2pt1cd;
                kp = kr * (tv + tn) / tn; ti = tv + tn; td = tv * tn / ti;
                q0i = kp * (1 + td / t0 + t0 / ti);
                q1i = -kp * (1 + 2.0 * td / t0); q2i = kp * td / t0;
                kri = kr; wdi = wd; si = st; tni = tn; tvi = tv;

                //kttotetacd();
                //this.degreen.Value = _mgradcd;
                //tetatocell();
                KT[0] = k2pt1cd; KT[1] = t12pt1cd; KT[2] = t22pt1cd; KT[3] = t0;
                meinMain.datatools.kttoteta(processmodel, KT, ref tetacd);
                this.degreen.Value = _mgradcd;
                tetatocell();
            } /*2pt1*/
            if (rbpt1.Checked)///*PT1*/ )
            {
                meinMain.ConvertToDouble(edk.Text, ref kpt1cd);
                meinMain.ConvertToDouble(Edt1.Text, ref  tpt1cd);
                /* first P-controller  from pt1*/
                suche_wd(tpt1cd, 0, 0, 1.5 * tab + tzafcd, -160 + phir, ref wd);
                kr = Math.Sqrt(1 + sqr(wd * tpt1cd)) / kpt1cd; q0p = kr; krp = kr; wdp = wd;

                /* PI-controller  from pt1*/
                tn = tpt1cd; /* polcompensation */
                tnn = tn;
                suche_wd(1e10, 0, 0, 1.5 * tab + tzafcd, -180 + phir, ref  wd);
                kr = wd * tn / kpt1cd; q0n = kr * (1 + tab / tn); q1n = -kr; krn = kr; wdn = wd;

                /* PDt1-controller  from pt1 , */
                tv = 1.5 * tab;       /* optimized, s.o.  */
                st = 3;   /*Stepdepth s.o.*/
                suche_wd(tv / st, tpt1cd, tv, 1.5 * tab + tzafcd, -150 + phir, ref wd);
                kr = 0.7 * Math.Sqrt(1 + sqr(wd * tpt1cd)) * Math.Sqrt(1 + sqr(wd * tv / st)) / Math.Sqrt(1 + sqr(wd * tv)) / kpt1cd;
                q0d = kr * 2.0; q1d = -kr;
                krd = kr; wdd = wd; sd = st;
                tvd = tv;

                /* PIDT1-controller  from pt1 */
                tv = 1.5 * tab;       /* TN polcompensation Tv optimized */
                st = 3;              /*Stepdepth */
                suche_wd(1e10, tv / st, tv, 1.5 * tab + tzafcd, -160 + phir, ref wd);
                tn = tpt1cd;  /*=polcompensation */
                kr = 0.7 * wd * tn * Math.Sqrt(1 + sqr(wd * tv / st)) / Math.Sqrt(1 + sqr(wd * tv)) / kpt1cd;
                tv = tab;
                kp = kr * (tv + tn) / tn; ti = tv + tn; td = tv * tn / ti; q0i = kp * (1 + td / tab + tab / ti);
                q1i = -kp * (1 + 2.0 * td / tab); q2i = kp * td / tab; kri = kr; wdi = wd; si = st; tni = tn;
                tv = 1.5 * tab;
                tni = tn; tvi = tv;
                //kttotetacd();
                //this.degreen.Value = _mgradcd;
                //tetatocell();
                KT[0] = kpt1cd; KT[1] = tpt1cd; KT[2] = 0; KT[3] = t0;
                meinMain.datatools.kttoteta(processmodel, KT, ref tetacd);
                this.degreen.Value = _mgradcd;
                tetatocell();
            } /*Pt1*/
            designDBOR();
            display();  /* display results */
            //tBcomment.Text = ptype;
            numbersfit();
        }

        
        
        public void rb2pt1_Click(object sender, EventArgs e)
        {
            processmodel = 0;
            ptype="2PT1";
            _mgradcd = 2;
            string1off();
            Edt2.Visible = true;
            label3.Visible = true;
            Label6.Visible = true;
            Label7.Visible = true;
            label8.Visible = true;
            tbAutoTZ.Visible = true;
            dgain.Visible = false;
            endgain.Visible = false;
            edk.Text = (k2pt1cd).ToString("G8");
            Edt1.Text = (t12pt1cd).ToString("G8");
            Edt2.Text = (t22pt1cd).ToString("G8");
            design_Click(sender,e);

        }
        private void rbit1_Click(object sender, EventArgs e)
        {
           processmodel = 1;
            ptype = "IT1";
            _mgradcd = 2;
            string1off();
            Edt2.Visible = false;
            label3.Visible = false;
            Label6.Visible = true;
            Label7.Visible = true;
            label8.Visible = true;
            tbAutoTZ.Visible = true;
            dgain.Visible = true;
            endgain.Visible = true;
            edk.Text = (kit1cd).ToString("G8");
            Edt1.Text = (tit1cd).ToString("G8");
            design_Click(sender, e);

        }

        private void rbpt1_Click(object sender, EventArgs e)
        {
            processmodel = 2;
            ptype = "PT1";
            _mgradcd = 1;
            string1off();
            Edt2.Visible = false;
            label3.Visible = false;
            Label6.Visible = true;
            dgain.Visible = false;
            Label7.Visible = true;
            label8.Visible = true;
            tbAutoTZ.Visible = true;
            endgain.Visible = false;
            edk.Text = (kpt1cd).ToString("G8");
            Edt1.Text = (tpt1cd).ToString("G8");
            design_Click(sender, e);
        }


        private void rbfz_Click(object sender, EventArgs e)
        {
            processmodel = 3;
            ptype = "F(z)";
            string1on();
            Edt2.Visible = false;
            label3.Visible = false;
            Label6.Visible = false;
            Label7.Visible = false;
            label8.Visible = false;
            tbAutoTZ.Visible = false;
            dgain.Visible = false;
            endgain.Visible = false;
            designDBOR();
            design_Click(sender, e);
            radiogroupMethod(sender, e);

        }

        private void degreen_ValueChanged(object sender, EventArgs e)
        {
            _mgradcd = (int)degreen.Value;
            dataGridView1.RowCount = _mgradcd;
            for (int i = 0; i < _mgradcd; i++) dataGridView1.Rows[i].HeaderCell.Value = (i + 1).ToString();
            numbersdntfit();
        }
 
 
        private void Btofz_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                List<string> pList = new List<string>();
                pList.Add(tBcomment.Text);
                pList.Add(degreen.Value.ToString());
                pList.Add("1 0");
                for (int i = 1; i <= degreen.Value ; i++)
                {
                    pList.Add(dataGridView1.Rows[i - 1].Cells[0].Value + " "
                        + dataGridView1.Rows[i - 1].Cells[1].Value);
                }
                double help = t0 * 1000.0;
                meinMain.ConvertToDouble(edto.Text, ref help);
                pList.Add((help/1000.0).ToString());  // in edto in msec, in file in sec
                pList.Add("0");  // integer delay n*T0
                if (edtt.Text != "0") pList.Add(edtt.Text); // continuous delay

                System.IO.StreamWriter sw = new System.IO.StreamWriter(saveFileDialog1.FileName);
                foreach (string s in pList)
                {
                    sw.WriteLine(s);
                }
                sw.Close();
            }
        }


        private void Bfztodf_Click(object sender, EventArgs e)
        {
            // Load *fz file, fill datastringgrid and try to convert into Pt1, It1 or 2PT1
            List<String> pList = new List<String>();
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                StreamReader filestream = new StreamReader(openFileDialog1.FileName, Encoding.Default);
                string line = "";
                while (line != null)
                {
                    line = filestream.ReadLine();
                    if (line != null)
                    {
                        pList.Add(line);
                    }
                }
                filestream.Close();
                //copyList2DigitalFilterForm(pList);   copy from DigitalFilter
                int i;
                int len = pList.Count;
                string[] outstr = new string[10];
                tBcomment.Text = pList[0];
                tBcomment.Visible = true;
                int Dmgrad = Convert.ToInt32(pList[1]);
                degreen.Value = Dmgrad;

                for (i = 0; i < tetacd.Length; i++) tetacd[i] = 0; //Clear
                if ((Dmgrad + 4) > len) MessageBox.Show(meinMain.fdigfilt.wrongfileformat);
                else
                {
                    meinMain.datatools.Str2NString(pList[2], ref outstr, ' ');  // a0, b0
                    //dataGridView1.Rows[0].Cells[1].Value = outstr[0];  //a0
                    if (outstr[1] != "0")
                    {
                        MessageBox.Show(b0notpossible);
                         meinMain.ConvertToDouble(outstr[1],ref tetacd[Dmgrad + 1]  );  // b0
                    }
                    else tetacd[Dmgrad + 1] = 0;
                    for (i = 3; i <= (Dmgrad + 2); i++)
                    {
                        meinMain.datatools.Str2NString(pList[i], ref outstr, ' ');
                        dataGridView1.Rows[i - 3].Cells[0].Value = outstr[0];
                        meinMain.ConvertToDouble(outstr[0],ref tetacd[i - 2] );  //ai
                        dataGridView1.Rows[i - 3].Cells[1].Value = outstr[1] ;
                        meinMain.ConvertToDouble(outstr[1],ref tetacd[i - 1 + Dmgrad]  );  //bi
                    }
                    meinMain.ConvertToDouble(pList[i],ref t0 );
                    edto.Text = (t0 * 1000).ToString("G16");  // in edt0 in msec, in File in sec
                    if (len > i + 2)  // some files contains  continuous delay
                        if (pList[i + 2] != "") edtt.Text = pList[i + 2];
                }
                rbfz.Checked=true;  // switch to Fz
                double _K = 0, _T1 = 0, _T2 = 0;
                string Typ = "", error = "";
                meinMain.datatools.kt_aus_tetab0(ref _K, ref _T1, ref _T2, t0, tetacd, Dmgrad, ref Typ, ref error);
                labelTyp.Text = "Type=  " + Typ;
                if (Typ == "PT1")
                {
                    //edk.Text = _K.ToString("G8");
                    //Edt1.Text = _T1.ToString("G8");
                    kpt1cd = _K;
                    tpt1cd = _T1;
                    rbpt1.Checked = true;
                }
                else
                    if (Typ == "2PT1")
                    {
                        //edk.Text = _K.ToString("G8");
                        //Edt1.Text = _T1.ToString("G8");
                        //Edt2.Text = _T2.ToString("G8");
                        k2pt1cd = _K;
                        t12pt1cd = _T1;
                        t22pt1cd = _T2;
                        rb2pt1.Checked = true;
                    }
                    else
                        if (Typ == "IT1")
                        {
                            //edk.Text = _K.ToString("G8");
                            //Edt1.Text = _T1.ToString("G8");
                            //Edt2.Text = _T2.ToString("G8");
                            kit1cd = _K;
                            tit1cd = _T1;
                            rbit1.Checked = true;
                        }
                        else rbfz_Click(sender,e);
            }
        }

 
        private void radioButton5_CheckedChanged(object sender, EventArgs e)
        {
            /*ideal algorithm*/
            Label7.Text="(+To/2)";
            tbAutoTZ.Text = (t0 / 2).ToString("G5");
            lalgor.Text = "y(n)=p1*y(n-1)+p2*y(n-2)+...+q0*xd(n)+q1*xd(n-1)...";
            algorithm='i';
            design_Click(sender, e);
        }

        private void radioButton6_CheckedChanged(object sender, EventArgs e)
        {
            /*real algorithm*/
            Label7.Text = "(+3To/2)";
            tbAutoTZ.Text = (3*t0 / 2).ToString("G5");

            lalgor.Text = "y(n)=p1*y(n-1)+p2*y(n-2)+...+q0*xd(n)+q1*xd(n-1)... + 1 delay";
            algorithm = 'r';
            design_Click(sender, e);
        }

        private void radioButton7_CheckedChanged(object sender, EventArgs e)
        {
            cdct = 0;//P
            radiogroupMethod( sender,  e);
        }

        private void radioButton8_CheckedChanged(object sender, EventArgs e)
        {
            cdct = 1;//PDT1
            radiogroupMethod(sender, e);
        }

        private void radioButton9_CheckedChanged(object sender, EventArgs e)
        {
            cdct = 2;//PI
            radiogroupMethod(sender, e);
        }

        private void radioButton10_CheckedChanged(object sender, EventArgs e)
        {
            cdct = 3;//PIDT1
            radiogroupMethod(sender, e);

        }

        private void radioButton11_CheckedChanged(object sender, EventArgs e)
        {
            cdct = 4;//DB(v)
            radiogroupMethod(sender, e);

        }

        private void radioButton12_CheckedChanged(object sender, EventArgs e)
        {
            cdct = 5;//DB(v+1)
            radiogroupMethod(sender, e);
        }
       private void radioButton13_CheckedChanged(object sender, EventArgs e)
        {
            cdct = 6;//OR
            radiogroupMethod(sender, e);
        }


       private void radiogroupMethod(object sender, EventArgs e)
       {
           design_Click(sender, e);

           if ((cdct < 4)&&(!rbfz.Checked)) 
               paneltohideKT.Visible = false;
           else paneltohideKT.Visible = true;

           RGir.Visible = true;
           if (cdct > 3)
           {
               dataGridView2.Visible = true;
           }
           else dataGridView2.Visible = false;
       }

         private void FContrdes_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
        }
        //---------------------------------------------------------------------------
        //---------------------------------------------------------------------------

        private void edk_Leave(object sender, EventArgs e)
        {
            switch (processmodel)
            {
                case 0: meinMain.ConvertToDouble(edk.Text,ref k2pt1cd ); break;
                case 1: meinMain.ConvertToDouble(edk.Text,ref kit1cd  ); break;
                case 2: meinMain.ConvertToDouble(edk.Text,ref kpt1cd ); break;
            }
            numbersdntfit();
        }

        private void edk_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) edk_Leave(sender, e);
        }

        private void edphir_Leave(object sender, EventArgs e)
        {

            meinMain.ConvertToDouble(edphir.Text,ref phir );
            numbersdntfit();

        }
        private void edphir_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d)edphir_Leave( sender,  e); 
        }

        private void edto_Leave(object sender, EventArgs e)
        {
            double help = t0 / 1000.0;
            meinMain.ConvertToDouble(edto.Text, ref help);
                t0=help* 1e-3; /* times in sec */
            if (rbideal.Checked)
                tbAutoTZ.Text = (t0 / 2).ToString("G5");
            else tbAutoTZ.Text = (3 * t0 / 2).ToString("G5");
            numbersdntfit();

        }

        private void edto_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) edto_Leave(sender, e);
        }

        private void Edt1_Leave(object sender, EventArgs e)
        {
            switch (processmodel)
            {
                case 0:  meinMain.ConvertToDouble(Edt1.Text,ref t12pt1cd ); break;
                case 1:  meinMain.ConvertToDouble(Edt1.Text,ref tit1cd ); break;
                case 2:  meinMain.ConvertToDouble(Edt1.Text,ref tpt1cd  ); break;
            }
            numbersdntfit();
        }

        private void Edt1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) Edt1_Leave(sender, e);
        }

        private void Edt2_Leave(object sender, EventArgs e)
        {
            meinMain.ConvertToDouble(Edt2.Text,ref t22pt1cd );
        }

        private void Edt2_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) Edt2_Leave(sender, e);
        }

        private void edtt_Leave(object sender, EventArgs e)
        {
            meinMain.ConvertToDouble(edtt.Text,ref tzafcd );
            numbersdntfit();
        }

        private void edtt_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) edtt_Leave(sender, e);
        }

        private void OKBtn_Click(object sender, EventArgs e)
        {
            // copy values into real time controller
            meinMain.frmStudContr.q0p = q0p;
            meinMain.frmStudContr.q0n = q0n;
            meinMain.frmStudContr.q1n = q1n;
            meinMain.frmStudContr.q0d = q0d;
            meinMain.frmStudContr.q1d = q1d;
            meinMain.frmStudContr.q0i = q0i;
            meinMain.frmStudContr.q1i = q1i;
            meinMain.frmStudContr.q2i = q2i;
            // daed beat has access directly from frmStudContr
            meinMain.frmadaptcon.q0p = q0p;
            meinMain.frmadaptcon.q0n = q0n;
            meinMain.frmadaptcon.q1n = q1n;
            meinMain.frmadaptcon.q0d = q0d;
            meinMain.frmadaptcon.q1d = q1d;
            meinMain.frmadaptcon.q0i = q0i;
            meinMain.frmadaptcon.q1i = q1i;
            meinMain.frmadaptcon.q2i = q2i;
            meinMain.frmadaptcon.readpv_valuesfromconrdes();
            Close();
        }

        private void edk_TextChanged(object sender, EventArgs e)
        {
            numbersdntfit();
        }

        private void FContrdes_Load(object sender, EventArgs e)
        {

        }


 


    }
}