﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace cRIO_Basics
{
    public partial class cRIO_Basics_2Channels : Form
    {
        float[] fAI, fAO = new float[2];
        bool initOK = false;
        cRIO_Schnittstelle.cRIO_Schnittstelle cRIO;

        public cRIO_Basics_2Channels()
        {
            InitializeComponent();
            cRIO = new cRIO_Schnittstelle.cRIO_Schnittstelle();
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
            timer1.Stop();
            if (initOK) cRIO.cRIOStop();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            fAO[0] = (float)numAO0.Value;
            fAO[1] = (float)numAO1.Value;
            fAI = cRIO.cRIOSend(fAO);
            numAI0.Value = (decimal)fAI[0];
            numAI1.Value = (decimal)fAI[1];
        }

        private void butInit_Click(object sender, EventArgs e)
        {
            try
            {
                if (!initOK)
                {
                    cRIO.cRIOStart("192.168.0.2", 80);
                    initOK = true;
                    label5NOK.Text = "OK";
                }
                timer1.Start();
            }
            catch (Exception ex)
            {
                MessageBox.Show("cRIO not ok"+ex.ToString());
            }

        }

        private void buttonDisc_Click(object sender, EventArgs e)
        {
            cRIO.cRIOStop();
        }
        public void inputcrio(short chan, ref double val)
        {
            //short valint = 0;
            //int ex = me2600AISingle(0, chan, me2600Def.AI2600_MINUS_10 + me2600Def.AI2600_SINGLE_ENDED, ref valint);

            //val = ((valint - 2048) * 20.0 / 4096);


        }

        public void outputcrio(short chan, double val)
        {
            //if (val > 10) val = 10;
            //if (val < -10) val = -10;
            //short outval = (short)((val + 10) * 4095.0 / 20.0);
            //int ex = me2600AOSingle(0, chan, outval);

        }

    }
}
